﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using System.Diagnostics;

namespace UltraGridWithImageColumnFilter
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            ultraGrid1.CreationFilter = new CreatingTextUIElement();
            ultraGrid1.AfterRowFilterChanged += new AfterRowFilterChangedEventHandler(ultraGrid1_AfterRowFilterChanged);
            ultraGrid1.BeforeCellActivate += new CancelableCellEventHandler(ultraGrid1_BeforeCellActivate);

            DataTable dt = new DataTable();
            dt.Columns.Add("Image", typeof(Image));
            dt.Columns.Add("Value", typeof(string));

            Image im1 = Resource1.Image1;
            Image im2 = Resource1.Image2;
            im1.Tag = "Create";
            im2.Tag = "Delete";


            dt.Rows.Add(im1, "Item 1");
            dt.Rows.Add(im2, "Item 2");
            dt.Rows.Add(im2, "Item 3");
            ultraGrid1.DataSource = dt;
        }

        void ultraGrid1_BeforeCellActivate(object sender, CancelableCellEventArgs e)
        {
            if (e.Cell.IsFilterRowCell)
            {
                e.Cell.Value = CreatingTextUIElement.FilterValue;
            }
        }


        void ultraGrid1_AfterRowFilterChanged(object sender, AfterRowFilterChangedEventArgs e)
        {
            if (e.NewColumnFilter.FilterConditions[0].CompareValue.GetType() == typeof(string))
            {
                e.NewColumnFilter.ClearFilterConditions();
                CreatingTextUIElement.FilterImage = null;
            }
            else
            {
                CreatingTextUIElement.FilterImage = e.NewColumnFilter.FilterConditions[0].CompareValue as Image;
            }
        }

        private void ultraGrid1_BeforeRowFilterDropDown(object sender, BeforeRowFilterDropDownEventArgs e)
        {
            int k = 0;
            while (k < e.ValueList.ValueListItems.Count)
            {
                ValueListItem item = e.ValueList.ValueListItems[k];
                if (item.DataValue.GetType() != typeof(Bitmap))
                {
                    e.ValueList.ValueListItems.Remove(item);
                    continue;
                }
                k++;
                item.Appearance.Image = item.DataValue;
                item.DisplayText = ((Bitmap)item.DataValue).Tag.ToString();
            }
            ValueListItem vli = new ValueListItem(null, "All");
            e.ValueList.ValueListItems.Insert(0, vli);
        }

        private void ultraGrid1_FilterCellValueChanged(object sender, FilterCellValueChangedEventArgs e)
        {
            CreatingTextUIElement.FilterValue = e.FilterCell.Text;
        }
    }

    public class CreatingTextUIElement : IUIElementCreationFilter
    {
        public static string FilterValue;
        public static Image FilterImage;

        public void AfterCreateChildElements(UIElement parent)
        {
            EditorWithTextDisplayTextUIElement El = parent as EditorWithTextDisplayTextUIElement;

            if (El != null && El.Parent.Parent.GetType() == typeof(EditorWithComboUIElement) && El.Rect.X < 50)
            {
                El.Text = "       " + FilterValue; // to do
                ImageUIElement asa = new ImageUIElement(El.Parent, FilterImage);
                asa.Rect = new Rectangle(El.Rect.X, El.Rect.Y, 18, 18);
                El.ChildElements.Add(asa);
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }

}
